tclap: TCLAP::Arg Class Reference

tclap 1.2.5

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
TCLAP::Arg Class Referenceabstract

A virtual base class that defines the essential data for all arguments. More...

`#include <Arg.h>`

Inheritance diagram for TCLAP::Arg:
[legend]
Collaboration diagram for TCLAP::Arg:
[legend]

## Public Member Functions
virtual | ~Arg ()
| Destructor. More...
virtual void | addToList (std::list< Arg * > &argList) const
| Adds this to the specified list of Args. More...
virtual bool | processArg (int *i, std::vector< std::string > &args)=0
| Pure virtual method meant to handle the parsing and value assignment of the string on the command line. More...
virtual bool | operator== (const Arg &a) const
| Operator ==. More...
const std::string & | getFlag () const
| Returns the argument flag. More...
const std::string & | getName () const
| Returns the argument name. More...
std::string | getDescription () const
| Returns the argument description. More...
virtual bool | isRequired () const
| Indicates whether the argument is required. More...
void | forceRequired ()
| Sets _required to true. More...
void | xorSet ()
| Sets the _alreadySet value to true. More...
bool | isValueRequired () const
| Indicates whether a value must be specified for argument. More...
bool | isSet () const
| Indicates whether the argument has already been set. More...
bool | isIgnoreable () const
| Indicates whether the argument can be ignored, if desired. More...
virtual bool | argMatches (const std::string &s) const
| A method that tests whether a string matches this argument. More...
virtual std::string | toString () const
| Returns a simple string representation of the argument. More...
virtual std::string | shortID (const std::string &valueId="val") const
| Returns a short ID for the usage. More...
virtual std::string | longID (const std::string &valueId="val") const
| Returns a long ID for the usage. More...
virtual void | trimFlag (std::string &flag, std::string &value) const
| Trims a value off of the flag. More...
bool | _hasBlanks (const std::string &s) const
| Checks whether a given string has blank chars, indicating that it is a combined SwitchArg. More...
void | setRequireLabel (const std::string &s)
| Sets the requireLabel. More...
virtual bool | allowMore ()
| Used for MultiArgs and XorHandler to determine whether args can still be set. More...
virtual bool | acceptsMultipleValues ()
| Use by output classes to determine whether an Arg accepts multiple values. More...
virtual void | reset ()
| Clears the Arg object and allows it to be reused by new command lines. More...

## Static Public Member Functions
static void | beginIgnoring ()
| Begin ignoring arguments since the "--" argument was specified. More...
static bool | ignoreRest ()
| Whether to ignore the rest. More...
static char | delimiter ()
| The delimiter that separates an argument flag/name from the value. More...
static char | blankChar ()
| The char used as a place holder when SwitchArgs are combined. More...
static char | flagStartChar ()
static const std::string | flagStartString ()
static const std::string | nameStartString ()
static const std::string | ignoreNameString ()
| The name used to identify the ignore rest argument. More...
static void | setDelimiter (char c)
| Sets the delimiter for all arguments. More...

## Protected Member Functions
void | _checkWithVisitor () const
| Performs the special handling described by the Visitor. More...
| Arg (const std::string &flag, const std::string &name, const std::string &desc, bool req, bool valreq, Visitor *v=NULL)
| Primary constructor. More...

## Protected Attributes
std::string | _flag
| The single char flag used to identify the argument. More...
std::string | _name
| A single word namd identifying the argument. More...
std::string | _description
| Description of the argument. More...
bool | _required
| Indicating whether the argument is required. More...
std::string | _requireLabel
| Label to be used in usage description. More...
bool | _valueRequired
| Indicates whether a value is required for the argument. More...
bool | _alreadySet
| Indicates whether the argument has been set. More...
Visitor * | _visitor
| A pointer to a visitor object. More...
bool | _ignoreable
| Whether this argument can be ignored, if desired. More...
bool | _xorSet
| Indicates that the arg was set as part of an XOR and not on the command line. More...
bool | _acceptsMultipleValues

## Detailed Description

A virtual base class that defines the essential data for all arguments.

This class, or one of its existing children, must be subclassed to do anything.

Definition at line 55 of file Arg.h.

## Constructor & Destructor Documentation

## ◆ Arg()

TCLAP::Arg::Arg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | bool | valreq,
|  | Visitor * | v = `NULL`
| ) |  |
| inlineprotected

Primary constructor.

YOU (yes you) should NEVER construct an Arg directly, this is a base class that is extended by various children that are meant to be used. Use SwitchArg, ValueArg, MultiArg, UnlabeledValueArg, or UnlabeledMultiArg instead.

Parameters

  flag | - The flag identifying the argument.
  name | - The name identifying the argument.
  desc | - The description of the argument, used in the usage.
  req | - Whether the argument is required.
  valreq | - Whether the a value is required for the argument.
  v | - The visitor checked by the argument. Defaults to NULL.

Definition at line 453 of file Arg.h.

References _flag, _name, flagStartString(), ignoreNameString(), nameStartString(), and toString().

Here is the call graph for this function:

## ◆ ~Arg()

TCLAP::Arg::~Arg | ( |  | ) |
| inlinevirtual

Destructor.

Definition at line 494 of file Arg.h.

## Member Function Documentation

## ◆ _checkWithVisitor()

void TCLAP::Arg::_checkWithVisitor | ( |  | ) | const
| inlineprotected

Performs the special handling described by the Visitor.

Definition at line 602 of file Arg.h.

References _visitor, and TCLAP::Visitor::visit().

Referenced by TCLAP::MultiSwitchArg::processArg().

Here is the call graph for this function:

## ◆ _hasBlanks()

bool TCLAP::Arg::_hasBlanks | ( | const std::string & | s | ) | const
| inline

Checks whether a given string has blank chars, indicating that it is a combined SwitchArg.

Implementation of _hasBlanks.

If so, return true, otherwise return false.

Parameters

  s | - string to be checked.

Definition at line 632 of file Arg.h.

References blankChar().

Here is the call graph for this function:

## ◆ acceptsMultipleValues()

bool TCLAP::Arg::acceptsMultipleValues | ( |  | ) |
| inlinevirtual

Use by output classes to determine whether an Arg accepts multiple values.

Definition at line 665 of file Arg.h.

References _acceptsMultipleValues.

Referenced by TCLAP::ZshCompletionOutput::getMutexList(), TCLAP::ZshCompletionOutput::printArg(), and TCLAP::DocBookOutput::printShortArg().

## ◆ addToList()

void TCLAP::Arg::addToList | ( | std::list< Arg * > & | argList | ) | const
| inlinevirtual

Adds this to the specified list of Args.

Overridden by Args that need to added to the end of the list.

Parameters

  argList | - The list to add this to.

Reimplemented in TCLAP::UnlabeledValueArg< T >, and TCLAP::UnlabeledMultiArg< T >.

Definition at line 655 of file Arg.h.

Referenced by TCLAP::CmdLine::add().

## ◆ allowMore()

bool TCLAP::Arg::allowMore | ( |  | ) |
| inlinevirtual

Used for MultiArgs and XorHandler to determine whether args can still be set.

Reimplemented in TCLAP::MultiArg< T >.

Definition at line 660 of file Arg.h.

## ◆ argMatches()

bool TCLAP::Arg::argMatches | ( | const std::string & | s | ) | const
| inlinevirtual

A method that tests whether a string matches this argument.

This is generally called by the processArg() method. This method could be re-implemented by a child to change how arguments are specified on the command line.

Parameters

  s | - The string to be compared to the flag/name to determine whether the arg matches.

Definition at line 581 of file Arg.h.

References _flag, _name, flagStartString(), and nameStartString().

Referenced by TCLAP::MultiSwitchArg::processArg(), and TCLAP::SwitchArg::processArg().

Here is the call graph for this function:

## ◆ beginIgnoring()

static void TCLAP::Arg::beginIgnoring | ( |  | ) |
| inlinestatic

Begin ignoring arguments since the "--" argument was specified.

Definition at line 191 of file Arg.h.

Referenced by TCLAP::IgnoreRestVisitor::visit().

## ◆ blankChar()

static char TCLAP::Arg::blankChar | ( |  | ) |
| inlinestatic

The char used as a place holder when SwitchArgs are combined.

Currently set to the bell char (ASCII 7).

Definition at line 208 of file Arg.h.

Referenced by TCLAP::CmdLine::_emptyCombined(), _hasBlanks(), and TCLAP::SwitchArg::combinedSwitchesMatch().

## ◆ delimiter()

static char TCLAP::Arg::delimiter | ( |  | ) |
| inlinestatic

The delimiter that separates an argument flag/name from the value.

Definition at line 202 of file Arg.h.

Referenced by TCLAP::SwitchArg::combinedSwitchesMatch(), longID(), TCLAP::MultiArg< T >::processArg(), TCLAP::ValueArg< T >::processArg(), shortID(), and trimFlag().

## ◆ flagStartChar()

static char TCLAP::Arg::flagStartChar | ( |  | ) |
| inlinestatic

Definition at line 217 of file Arg.h.

References TCLAP_FLAGSTARTCHAR.

Referenced by TCLAP::CmdLine::_emptyCombined(), TCLAP::ZshCompletionOutput::getMutexList(), and TCLAP::ZshCompletionOutput::printOption().

## ◆ flagStartString()

static const std::string TCLAP::Arg::flagStartString | ( |  | ) |
| inlinestatic

Definition at line 227 of file Arg.h.

References TCLAP_FLAGSTARTSTRING.

Referenced by Arg(), argMatches(), TCLAP::SwitchArg::combinedSwitchesMatch(), longID(), shortID(), and toString().

## ◆ forceRequired()

void TCLAP::Arg::forceRequired | ( |  | ) |
| inline

Sets _required to true.

This is used by the XorHandler. You really have no reason to ever use it.

Definition at line 641 of file Arg.h.

References _required.

## ◆ getDescription()

std::string TCLAP::Arg::getDescription | ( |  | ) | const
| inline

Returns the argument description.

Definition at line 545 of file Arg.h.

References _description, _required, and _requireLabel.

Referenced by TCLAP::UnlabeledMultiArg< T >::operator==(), TCLAP::UnlabeledValueArg< T >::operator==(), and TCLAP::ZshCompletionOutput::printOption().

## ◆ getFlag()

const std::string & TCLAP::Arg::getFlag | ( |  | ) | const
| inline

Returns the argument flag.

Definition at line 558 of file Arg.h.

References _flag.

Referenced by TCLAP::ZshCompletionOutput::getMutexList(), and TCLAP::ZshCompletionOutput::printOption().

## ◆ getName()

const std::string & TCLAP::Arg::getName | ( |  | ) | const
| inline

Returns the argument name.

Definition at line 560 of file Arg.h.

References _name.

Referenced by TCLAP::ZshCompletionOutput::getMutexList(), TCLAP::UnlabeledMultiArg< T >::operator==(), TCLAP::UnlabeledValueArg< T >::operator==(), TCLAP::ZshCompletionOutput::printArg(), and TCLAP::ZshCompletionOutput::printOption().

## ◆ ignoreNameString()

static const std::string TCLAP::Arg::ignoreNameString | ( |  | ) |
| inlinestatic

The name used to identify the ignore rest argument.

Definition at line 241 of file Arg.h.

Referenced by Arg().

## ◆ ignoreRest()

static bool TCLAP::Arg::ignoreRest | ( |  | ) |
| inlinestatic

Whether to ignore the rest.

Definition at line 196 of file Arg.h.

Referenced by TCLAP::CmdLine::parse(), TCLAP::MultiArg< T >::processArg(), TCLAP::MultiSwitchArg::processArg(), TCLAP::SwitchArg::processArg(), and TCLAP::ValueArg< T >::processArg().

## ◆ isIgnoreable()

bool TCLAP::Arg::isIgnoreable | ( |  | ) | const
| inline

Indicates whether the argument can be ignored, if desired.

Definition at line 574 of file Arg.h.

References _ignoreable.

## ◆ isRequired()

bool TCLAP::Arg::isRequired | ( |  | ) | const
| inlinevirtual

Indicates whether the argument is required.

Reimplemented in TCLAP::MultiArg< T >.

Definition at line 562 of file Arg.h.

References _required.

Referenced by TCLAP::CmdLine::add(), TCLAP::XorHandler::check(), TCLAP::ZshCompletionOutput::printArg(), and TCLAP::DocBookOutput::printShortArg().

## ◆ isSet()

bool TCLAP::Arg::isSet | ( |  | ) | const
| inline

Indicates whether the argument has already been set.

Only true if the arg has been matched on the command line.

Definition at line 566 of file Arg.h.

References _alreadySet, and _xorSet.

Referenced by TCLAP::XorHandler::check().

## ◆ isValueRequired()

bool TCLAP::Arg::isValueRequired | ( |  | ) | const
| inline

Indicates whether a value must be specified for argument.

Definition at line 564 of file Arg.h.

References _valueRequired.

Referenced by TCLAP::ZshCompletionOutput::printOption().

## ◆ longID()

std::string TCLAP::Arg::longID | ( | const std::string & | valueId = `"val"` | ) | const
| inlinevirtual

Returns a long ID for the usage.

Parameters

  valueId | - The value used in the id.

Reimplemented in TCLAP::ValueArg< T >, TCLAP::UnlabeledValueArg< T >, TCLAP::UnlabeledMultiArg< T >, TCLAP::MultiArg< T >, and TCLAP::MultiSwitchArg.

Definition at line 514 of file Arg.h.

References _flag, _name, _valueRequired, delimiter(), flagStartString(), and nameStartString().

Referenced by TCLAP::CmdLine::add(), TCLAP::MultiSwitchArg::longID(), TCLAP::MultiArg< T >::longID(), and TCLAP::ValueArg< T >::longID().

Here is the call graph for this function:

## ◆ nameStartString()

static const std::string TCLAP::Arg::nameStartString | ( |  | ) |
| inlinestatic

Definition at line 236 of file Arg.h.

References TCLAP_NAMESTARTSTRING.

Referenced by Arg(), argMatches(), TCLAP::SwitchArg::combinedSwitchesMatch(), TCLAP::StdOutput::failure(), TCLAP::ZshCompletionOutput::getMutexList(), longID(), TCLAP::ZshCompletionOutput::printOption(), shortID(), and toString().

## ◆ operator==()

bool TCLAP::Arg::operator== | ( | const Arg & | a | ) | const
| inlinevirtual

Operator ==.

Equality operator. Must be virtual to handle unlabeled args.

Parameters

  a | - The Arg to be compared to this.

Reimplemented in TCLAP::UnlabeledValueArg< T >, and TCLAP::UnlabeledMultiArg< T >.

Definition at line 537 of file Arg.h.

References _flag, and _name.

## ◆ processArg()

virtual bool TCLAP::Arg::processArg | ( | int * | i,
|  | std::vector< std::string > & | args
| ) |  |
| pure virtual

Pure virtual method meant to handle the parsing and value assignment of the string on the command line.

Parameters

  i | - Pointer the the current argument in the list.
  args | - Mutable list of strings. What is passed in from main.

Implemented in TCLAP::ValueArg< T >, TCLAP::UnlabeledValueArg< T >, TCLAP::UnlabeledMultiArg< T >, TCLAP::SwitchArg, TCLAP::MultiSwitchArg, and TCLAP::MultiArg< T >.

## ◆ reset()

void TCLAP::Arg::reset | ( |  | ) |
| inlinevirtual

Clears the Arg object and allows it to be reused by new command lines.

Reimplemented in TCLAP::ValueArg< T >, TCLAP::SwitchArg, TCLAP::MultiSwitchArg, and TCLAP::MultiArg< T >.

Definition at line 670 of file Arg.h.

References _alreadySet, and _xorSet.

Referenced by TCLAP::MultiArg< T >::reset(), TCLAP::SwitchArg::reset(), and TCLAP::ValueArg< T >::reset().

## ◆ setDelimiter()

static void TCLAP::Arg::setDelimiter | ( | char | c | ) |
| inlinestatic

Sets the delimiter for all arguments.

Parameters

  c | - The character that delimits flags/names from values.

Definition at line 247 of file Arg.h.

## ◆ setRequireLabel()

void TCLAP::Arg::setRequireLabel | ( | const std::string & | s | ) |
| inline

Sets the requireLabel.

Used by XorHandler. You shouldn't ever use this.

Parameters

  s | - Set the requireLabel to this value.

Definition at line 576 of file Arg.h.

References _requireLabel.

## ◆ shortID()

std::string TCLAP::Arg::shortID | ( | const std::string & | valueId = `"val"` | ) | const
| inlinevirtual

Returns a short ID for the usage.

Parameters

  valueId | - The value used in the id.

Reimplemented in TCLAP::ValueArg< T >, TCLAP::UnlabeledValueArg< T >, TCLAP::UnlabeledMultiArg< T >, TCLAP::MultiArg< T >, and TCLAP::MultiSwitchArg.

Definition at line 496 of file Arg.h.

References _flag, _name, _required, _valueRequired, delimiter(), flagStartString(), and nameStartString().

Referenced by TCLAP::ZshCompletionOutput::printOption(), TCLAP::DocBookOutput::printShortArg(), TCLAP::MultiSwitchArg::shortID(), TCLAP::MultiArg< T >::shortID(), and TCLAP::ValueArg< T >::shortID().

Here is the call graph for this function:

## ◆ toString()

std::string TCLAP::Arg::toString | ( |  | ) | const
| inlinevirtual

Returns a simple string representation of the argument.

Primarily for debugging.

Definition at line 590 of file Arg.h.

References _flag, _name, flagStartString(), and nameStartString().

Referenced by Arg(), TCLAP::SwitchArg::processArg(), TCLAP::UnlabeledMultiArg< T >::UnlabeledMultiArg(), and TCLAP::UnlabeledValueArg< T >::UnlabeledValueArg().

Here is the call graph for this function:

## ◆ trimFlag()

void TCLAP::Arg::trimFlag | ( | std::string & | flag,
|  | std::string & | value
| ) |  | const
| inlinevirtual

Trims a value off of the flag.

Implementation of trimFlag.

Parameters

  flag | - The string from which the flag and value will be trimmed. Contains the flag once the value has been trimmed.
  value | - Where the value trimmed from the string will be stored.

Definition at line 611 of file Arg.h.

References delimiter().

Here is the call graph for this function:

## ◆ xorSet()

void TCLAP::Arg::xorSet | ( |  | ) |
| inline

Sets the _alreadySet value to true.

This is used by the XorHandler. You really have no reason to ever use it.

Definition at line 646 of file Arg.h.

References _alreadySet, and _xorSet.

## Member Data Documentation

## ◆ _acceptsMultipleValues

bool TCLAP::Arg::_acceptsMultipleValues
| protected

Definition at line 149 of file Arg.h.

Referenced by acceptsMultipleValues(), and TCLAP::MultiArg< T >::MultiArg().

## ◆ _alreadySet

bool TCLAP::Arg::_alreadySet
| protected

Indicates whether the argument has been set.

Indicates that a value on the command line has matched the name/flag of this argument and the values have been set accordingly.

Definition at line 128 of file Arg.h.

Referenced by isSet(), TCLAP::MultiSwitchArg::processArg(), reset(), and xorSet().

## ◆ _description

std::string TCLAP::Arg::_description
| protected

Description of the argument.

Definition at line 103 of file Arg.h.

Referenced by getDescription().

## ◆ _flag

std::string TCLAP::Arg::_flag
| protected

The single char flag used to identify the argument.

This value (preceded by a dash {-}), can be used to identify an argument on the command line. The _flag can be blank, in fact this is how unlabeled args work. Unlabeled args must override appropriate functions to get correct handling. Note that the _flag does NOT include the dash as part of the flag.

Definition at line 89 of file Arg.h.

Referenced by Arg(), argMatches(), TCLAP::SwitchArg::combinedSwitchesMatch(), getFlag(), longID(), operator==(), shortID(), and toString().

## ◆ _ignoreable

bool TCLAP::Arg::_ignoreable
| protected

Whether this argument can be ignored, if desired.

Definition at line 141 of file Arg.h.

Referenced by isIgnoreable(), TCLAP::MultiSwitchArg::processArg(), TCLAP::SwitchArg::processArg(), TCLAP::UnlabeledMultiArg< T >::UnlabeledMultiArg(), and TCLAP::UnlabeledValueArg< T >::UnlabeledValueArg().

## ◆ _name

std::string TCLAP::Arg::_name
| protected

A single word namd identifying the argument.

This value (preceded by two dashed {–}) can also be used to identify an argument on the command line. Note that the _name does NOT include the two dashes as part of the _name. The _name cannot be blank.

Definition at line 98 of file Arg.h.

Referenced by Arg(), argMatches(), getName(), longID(), operator==(), shortID(), and toString().

## ◆ _required

bool TCLAP::Arg::_required
| protected

Indicating whether the argument is required.

Definition at line 108 of file Arg.h.

Referenced by forceRequired(), getDescription(), isRequired(), and shortID().

## ◆ _requireLabel

std::string TCLAP::Arg::_requireLabel
| protected

Label to be used in usage description.

Normally set to "required", but can be changed when necessary.

Definition at line 114 of file Arg.h.

Referenced by getDescription(), and setRequireLabel().

## ◆ _valueRequired

bool TCLAP::Arg::_valueRequired
| protected

Indicates whether a value is required for the argument.

Note that the value may be required but the argument/value combination may not be, as specified by _required.

Definition at line 121 of file Arg.h.

Referenced by isValueRequired(), longID(), and shortID().

## ◆ _visitor

Visitor* TCLAP::Arg::_visitor
| protected

A pointer to a visitor object.

The visitor allows special handling to occur as soon as the argument is matched. This defaults to NULL and should not be used unless absolutely necessary.

Definition at line 136 of file Arg.h.

Referenced by _checkWithVisitor().

## ◆ _xorSet

bool TCLAP::Arg::_xorSet
| protected

Indicates that the arg was set as part of an XOR and not on the command line.

Definition at line 147 of file Arg.h.

Referenced by isSet(), reset(), and xorSet().

The documentation for this class was generated from the following file:

- Arg.h